
"""
Code explanations:
    Main call: guess_words_gpt2, word_list_gpt2, embeddings_gpt2, indices = from_scratch_to_guess(model_name = 'gpt2', distance_type='euclidian')
    this calls to: 
        from_model_to_emb(model_name, word_list,  disable_short,   min_len) to take the model words embedding
        and
        guess_words, cue_word_indices= word_list_and_embedding_to_guess(word_list, embeddings,distance_type,
                                                                        cue_words_list, k, disable_sim, temp = 1)
        to extract guess words
    For prompt associations:
        run run_prompt_associations
        

"""
import time
from main_functions_turing_cue_words import *
from numpy.linalg import norm
global save_path
save_path = r'./from_sep_30_files'
from english_words import english_words_lower_alpha_set
global full_word_list
global cue_words_list
global full_word_list_short
import openai

cue_words_list = np.load(save_path + os.sep +'all_cue_words_october_1.npy')
path_for_prompts = # fill out path for prompt

full_word_list = english_words_lower_alpha_set#np.load(save_path + os.sep +'all_possible_words_guess_or_cue.npy')
full_word_list = np.array(list(full_word_list))
freqs = find_freqs(full_word_list)
argsort_freqs = np.argsort(freqs)[::-1]
indices_common_6000 = argsort_freqs[:6000]

freqs_short = np.array(freqs)[indices_common_6000]
full_word_list_short = full_word_list[indices_common_6000]
full_word_list_short = np.array(list(full_word_list_short) + list(cue_words_list))
#full_word_list_short = np.array([w for w in full_word_list_short if w not in stop_words])


def find_most_similar_embedding(embeddings, word, distance_type = 'cosine', temp = 1, tokenizer = [], k = 0):
    """    

    Parameters
    ----------
    embeddings : TYPE
        DESCRIPTION.
    distance_type : TYPE, optional
        DESCRIPTION. The default is 'cosyne'. Can also be 'Euclidian'
    temp : TYPE, optional
        DESCRIPTION. The default is 1.
    disable_similar : TYPE, optional
        DESCRIPTION. The default is True.
    disable_short : TYPE, optional
        DESCRIPTION. The default is False.

    Returns
    -------
    None.
    """
    #if isinstance(word, class_or_tuple)
    if checkEmptyList(tokenizer) and isinstance(word, str):
        word = tokenizer.encode(word, add_prefix_space = True)[0]
    vector = embeddings[word,:].reshape((1,-1))
    if distance_type.lower() == 'euclidian':
        if isinstance(embeddings, np.ndarray):
            try:
                dist = np.sum((embeddings - vector)**2, 1)
            except:
                print(vector)
                
        else:
            dist = np.sum((embeddings - vector).detach().numpy()**2, 1)
    elif distance_type.lower() == 'cosine':
        dist = np.array([np.abs(cosine_sim(vector, embeddings[vec2_loc])) for vec2_loc in range(embeddings.shape[0])])
    else:
        raise ValueErrror('Unknown distance type')
    dist[word] = np.inf

    

    dist = dist.flatten()
    min_dists = np.argsort(dist)

    if k == 0: k = int(temp*35)
    if k == 1:
        return [min_dists[0]]
    return min_dists[:k]
    
def detect_similar(word1, word2, min_include = 0.6):
    if min_include < 1:
        min_include = int(min_include * np.min([len(word1), len(word2)]))    
    if word1 in word2 or word2 in word1: # 
        return True #word1 in word2 or word2 in word1 
    elif min_include == np.min([len(word1), len(word2)]):
        return False
    return detect_similar(word1[:-1], word2, min_include) or detect_similar(word1, word2[:-1], min_include ) or detect_similar(word1[1:], word2, min_include ) or detect_similar(word1, word2[1:], min_include)

def from_model_to_emb(model_name = 'gpt2', word_list = [],  disable_short = False,
                      min_len = 3, cue_words_list = cue_words_list, return_cue_indices = True):
    if checkEmptyList(cue_words_list):
        cue_words_list = np.load(save_path + os.sep +'all_cue_words_october_1.npy')
    if checkEmptyList(word_list):
        word_list = np.load(save_path + os.sep +'all_possible_words_guess_or_cue.npy')
    if model_name.lower() == 'gpt2':
        tokenizer = GPT2Tokenizer.from_pretrained("gpt2")
        model = GPT2LMHeadModel.from_pretrained('gpt2') 
        # below is a dict of embedding - numpy array of embeddings; word_list: numpy array of words; indices
        gpt_emb = np.load('all_embbeding_gpt2.npy',allow_pickle=True).item()
        word_list = np.array(gpt_emb['word_list'])
        embedding_init = gpt_emb['embedding']
        #word_embeddings = model.transformer.wte.weight
        #word_list = gpt_emb[0]
    elif model_name.lower() == 'gpt3':
        try: gpt_emb
        except:
            gpt_emb = np.load('all_embbeding_gpt3.npy',allow_pickle=True)#.item()
        word_list = gpt_emb[0]#np.load(important_files_path + '/all_embs_words.npy')#.item()[1]
        embedding_init = np.vstack(gpt_emb[1])
        additional_gpt3 = np.load('additional_gpt3.npy',allow_pickle=True).item()
        word_list  = np.array(list(word_list ) + list(additional_gpt3['word_list']))
        embedding_init = np.vstack([embedding_init, additional_gpt3['embeddings']])
    elif model_name.lower() == 'word2vec':
        # below is a dict of embedding - numpy array of embeddings; word_list: numpy array of words; for word2vec
        gpt_emb = np.load(save_path + os.sep +'all_embbeding_word2vec.npy',allow_pickle=True).item()
        word_list = np.array(gpt_emb['word_list'])
        embedding_init = gpt_emb['embedding']
    else:
        raise ValueError('Unknown Model Name!')
   

    is_intersect = [w.lower().strip() in full_word_list_short for w in word_list]
    
    if return_cue_indices:
        
        array_cue_indices = np.array([np.where(word_list == cue)[0][0] 
                                      for cue in cue_words_list])  
    embeddings = embedding_init[is_intersect,:]
    word_list = np.char.strip(np.char.lower(np.array(word_list[is_intersect])))
    long_words = [len(w) > 1 for w in word_list]
    word_list = word_list[long_words]
    embeddings = embeddings[long_words]
    if disable_short:
        long_words = [len(w) >= min_len for w in word_list]
        word_list = word_list[long_words]
        embeddings = embeddings[long_words]
    if return_cue_indices:
        #print([cue in word_list for cue in cue_words_list])
        #[print(np.where(word_list == cue)) for cue in cue_words_list]
        array_cue_indices = np.array([np.where(word_list == cue)[0][0] for cue in cue_words_list])        
    if embeddings.shape[0] != len(word_list):
        raise ValueError('An error!')
    return word_list, embeddings, array_cue_indices

def word_list_and_embedding_to_guess(word_list, embeddings,distance_type = 'cosine',
                                      cue_words_list = cue_words_list, array_cue_indices = [],
                                      k = 50, disable_sim = True, tokenizer = [],temp = 1):
    if checkEmptyList(cue_words_list):
        cue_words_list = np.load(save_path + os.sep +'all_cue_words_october_1.npy')
        

    guess_words = []
    cue_word_indices = []    
    pairs = []
    for cue_word_num, cue_word in enumerate(cue_words_list):
        #if checkEmptyList(array_cue_indices):
        try:
            cue_word_index = np.where(np.char.lower(word_list) == cue_word.lower())[0]
            if len(cue_word_index) == 0: print('cue word: %s not found!'%cue_word)
            else:  cue_word_index = cue_word_index[0]
        except:
            cue_word_index = array_cue_indices[cue_word_num]
        cue_word_indices.append(cue_word_index)
        guess_words.append(find_guess(embeddings, cue_word, cue_word_index, word_list, distance_type , temp, 
                                           tokenizer , k , disable_sim))
        print('here is a pair!')
        print([cue_word, guess_words[-1]])
        pairs.append([cue_word, guess_words[-1]])
    return guess_words, cue_word_indices, pairs
        
        
       
def from_scratch_to_guess(model_name = 'gpt2', word_list = [],  disable_short = False, temp = 1,
                      min_len = 3,  distance_type = 'cosine', cue_words_list = [], k = 50, disable_sim = True):
    """
    This is the main function to run for the embeddings-based associations
    """
    
    word_list, embeddings, array_cue_indices = from_model_to_emb(model_name, word_list,  disable_short,   min_len)
    guess_words, cue_word_indices, pairs = word_list_and_embedding_to_guess(word_list, embeddings, distance_type,
                                                                    cue_words_list, array_cue_indices, k, disable_sim, temp = 1)
    return guess_words, word_list, embeddings, cue_word_indices, pairs
                                                                     
                                                                     
      
def find_guess(embeddings, word, word_index, word_list, distance_type = 'gpt2', temp = 1, 
                                   tokenizer = [], k = 70, disable_sim = True, disable_stop = True, 
                                   disable_short = True, min_len = 3)  :
    similar_inds = find_most_similar_embedding(embeddings, word_index, distance_type = distance_type, temp = temp, 
                                       tokenizer = [], k = k)  

    similar_words = word_list[similar_inds]
    
    if disable_sim:
        print('sim1')
        print(similar_words)
        similar_words = [word2 for word2 in similar_words if not detect_similar(word, word2)]
    if disable_stop:
        # print('sim2')
        # print(similar_words)        
        similar_words = [word2 for word2 in similar_words if word2 not in stop_words]
    if disable_short:
        # print('sim3')
        # print(similar_words)        
        similar_words = [word2 for word2 in similar_words if len(word2) >= min_len]
        
    if temp == 1:
        #print('similar words!!!')
        #print(similar_words)
        
        guess_word = similar_words[0]
        #print(guess_word)
    else:
        if temp < len(similar_words):
            similar_words = similar_words[:temp]
        guess_word = np.random.choice(similar_words,1)[0]
    return guess_word

def create_associations_prompt(cue_current, model_name, 
                               df = [] , params_dict ={}, seed = 0, num_cues = 3, cue_str = 'Cue: ', guess_str = 'Guess: '):
  cue_back = [cue_current]
  machine_guess = cue_current
  cont = cue_current in cue_back or machine_guess == cue_current
  while cont:
    back = create_back(cue_current, df, seed , num_cues, cue_str, guess_str )  
    cue_back = back[0]
  response = openai.Completion.create(      
      prompt = back[2],
      model=model_name,            
      stop=["Guess:"],
      **params_dict
    )
  machine_guess = response["choices"][0]['text'].strip().split()[0]
  return back, response, machine_guess



def create_back(cue_current, df = [], seed = 0, num_cues = 3, cue_str = 'Cue: ', guess_str = 'Guess: '):
  if checkEmptyList(df):
      df = pd.read_csv(path_for_prompts)
  np.random.seed(seed)
  choice_cols = np.random.choice(df.shape[1], np.min([num_cues, df.shape[1]]), replace = False)
  choice_rows = np.random.choice(df.shape[0], np.min([num_cues, df.shape[1]]), replace = True)
  cue_back = df.columns[choice_cols]
  guess_back = [df.iloc[choice_rows[col_count], col_val] for col_count, col_val in enumerate(choice_cols)]
  prompt = '\n\n '.join([cue_str + cue_back[i] + ' \n' + guess_str + guess_back[i] for i in range(len(guess_back))])
  prompt = prompt + '\n\n '   + cue_str + ' ' + cue_current + ' \nGuess: '
  return cue_back, guess_back, prompt            


def find_most_similar_words(words_list, embeddings, ):
    if disable_similar():
        [detect_similar(word1, word2)]
    
    
def cosine_sim(vec1, vec2):
    return np.dot(vec1,vec2)/(norm(vec2)*norm(vec2))

def run_prompt_associations(model_name = "text-davinci-002" , num_cues = 3, back_per_cue = 3, df = [], 
                            num_associations = 0, cue_words = cue_words_list, 
                            params_dict = {'temperature' : 0.5,'max_tokens' : 60,'top_p' : 1.0, 'frequency_penalty' : 0.5, 'presence_penalty' : 0.0, 'max_tokens':3}):  
   if checkEmptyList(df):
       df = pd.read_csv(path_for_prompts)
   openai.api_key = # some openai key                 
   dict_davinci_assoc = {}
   dict_davinci_back = {}
   if checkEmptyList(cue_words):
       cue_words = np.load(save_path + os.sep +'all_cue_words_october_1.npy')
   take_example = np.random.randint(1, back_per_cue, size = len(cue_words))
   if num_associations == 0:
       num_associations = len(cue_words) * back_per_cue
    
   df_assoc = pd.DataFrame(columns = cue_words, index = np.arange(back_per_cue))
   seeds = np.arange(num_associations)
   counter = 0
   for i, cue_word in enumerate(cue_words):
       for repeat in range(back_per_cue):
           back, response, machine_guess = create_associations_prompt(cue_word, model_name = model_name, df =df , 
                                                                      params_dict = params_dict, seed = seeds[counter], num_cues = num_cues)
           if cue_word not in dict_davinci_assoc.keys():
               dict_davinci_assoc[cue_word] = []
               dict_davinci_back[cue_word] = []
    
           dict_davinci_assoc[cue_word].append(machine_guess)
           dict_davinci_back[cue_word].append(back[2])
           df_assoc.loc[repeat, cue_word] = machine_guess #guess, cue
           counter += 1
           time.sleep(3.5)
           print('############################')
           print('current cue:' + cue_word)
           print('guess:' + machine_guess)
           print('Background:' + back[-1])
           print('############################')
    
   ### Create shorter versions
   df_assoc_short = pd.DataFrame(columns = cue_words, data = [ [df_assoc.iloc[take_example, cue_num] for cue_num in range(len(cue_words))] ])
   dict_davinci_assoc_short = {cue: dict_davinci_assoc[cue][take_example[cue_num]] for cue_num, cue in enumerate(cue_words)}
   dict_davinci_back_short =  {cue: dict_davinci_back[cue][take_example[cue_num]] for cue_num, cue in enumerate(cue_words)}
    
   df_assoc_short = df_assoc.T.reset_index()
   df_assoc_short.columns = ['Cue Words','Guess Words']
    
   return  dict_davinci_assoc, dict_davinci_back, df_assoc, dict_davinci_assoc_short, dict_davinci_back_short, df_assoc_short



    
    
    