

from english_words import english_words_lower_alpha_set
from nltk.stem.wordnet import WordNetLemmatizer
from transformers import GPT2LMHeadModel, AutoModelForMaskedLM, AutoTokenizer, GPT2Tokenizer
import nltk
nltk.download('omw-1.4')
from stop_words import get_stop_words
import numpy as np

 
import pandas as pd
from sklearn.decomposition import PCA
import matplotlib.pyplot as plt
from random import choices
import random
from nltk.corpus import wordnet as wn
from wordfreq import word_frequency
from random_word import RandomWords
import random
nltk.download('punkt')
nltk.download('averaged_perceptron_tagger')
nltk.download('stopwords')
from nltk.corpus import stopwords

global stop_words
stop_words = set(stopwords.words('english'))

import re
from nltk.stem.wordnet import WordNetLemmatizer
import os

global signs_to_remove
signs_to_remove =  '-=█_░─"1234567890!@#$%^&★*(){}+,.:;><?]['
global bin_size 
bin_size = {'VB': 1, 'NN': 20, 'JJ': 15}
global words_possible_by_gpt2 
words_possible_by_gpt2 = np.load('words_valid_gpt2.npy')
words_possible_by_gpt2 = np.array([w.strip().lower() for w in words_possible_by_gpt2])

global not_to_use 
not_to_use = ['gregory','alfred','mohammed','allah','sara','herald', 'sharon']


def checkEmptyList(obj):
    return isinstance(obj, list) and len(obj) == 0 

def categorize_word(word):
  text = nltk.word_tokenize(word)
  cat = nltk.pos_tag(text)
  if len(cat) == 0:
      return [(word,'')]
  elif len(cat[0]) == 2:
    return cat
  else:
    return [(word,'')]

def get_word_freq(word, lang = 'en',wordlist = 'small',minimum = 1e-95):
  try:
    freq = word_frequency(word, lang, wordlist = wordlist, minimum=minimum)
  except:
    freq = 0
  return freq

def find_freqs(words_list, minimum = 0, wordlist_type = 'small', lang = 'en'):
  return [get_word_freq(word, lang,wordlist_type,minimum) for word in words_list]

def lists2list(xss)    :
    return [x for xs in xss for x in xs] 

def take_from_bin(df, interval = 30, n_groups = 50, to_sort_by = 'freq', seed = 0 ):
   np.random.seed(seed)
   #n_groups_original = n_groups
   #n_groups = n_groups + 5
   # this functions get a dataframe with the columns 'word, cat, freq'
   df = df.sort_values(by = to_sort_by, ascending = False)
   #total_to_take = interval * n_groups
   group_vector = np.repeat(np.arange(n_groups), interval)
   total_to_take = len(group_vector)
   df = df.iloc[:total_to_take,:]
   random_indices = np.random.randint(0,interval, size = n_groups)
   if df.shape[0] < len(group_vector):
       print('df shape')
       print(df.shape)
       print(len(group_vector))
       print(interval)
   df['group']  = group_vector
   words_to_take = [df['word'].values[group_vector == group][random_indices[group]] for group in np.arange(n_groups)]
   words_to_take_dfs = pd.concat([df.iloc[np.where(group_vector == group)[0],:].iloc[random_indices[group],:].to_frame()
                                  for group in np.arange(n_groups)], axis = 0)
   #words_to_take = 
   return words_to_take, words_to_take_dfs
   
def treat_verbs(verb):
    cat = categorize_word(verb)[0][-1]
    if cat.startswith('VB'):
        verb = WordNetLemmatizer().lemmatize(verb,'v')
        if verb.endswith('ing') and len(verb) > 4:
            verb = ''
            
    return verb
        
    
    
    
    
def from_english_words_to_dict_dfs_freq( minimum = 1e-35, selected_cat = ['JJ','NN','VB'],
                                        plural_same=True, min_len_cue = 3, cols_names =['word','freq','cat'],
                                        wordlist_type = 'small', lang = 'en',interval = 30,
                                        signs_to_remove =  signs_to_remove, n_groups  = 50,
                                        english_words =  english_words_lower_alpha_set, general_verbs = True) :
    english_words = np.array(list(english_words))
    word_list = np.array([treat_verbs(s) for s in english_words])
    word_list = [w for w in word_list if w in words_possible_by_gpt2]
    

    word_list = [s.replace(" ", "") for s in word_list]
    word_list = [s.replace("]", "") for s in word_list]
    word_list = [s.replace("[", "") for s in word_list]
    word_list = [s.replace("'", "") for s in word_list]
    word_list = [s for s in word_list if s.lower() not in not_to_use]
    list_of_freqs =  np.array(find_freqs(word_list , minimum, wordlist_type, lang))
    list_of_cats = np.array([categorize_word(word)[0][-1] for word in word_list ])
    list_of_cats = np.array([cat if not cat.startswith('VB') else 'VB' for cat in list_of_cats ])
    word_list = np.array(word_list)[list_of_freqs > minimum]
    list_of_cats= list_of_cats[list_of_freqs > minimum]
    list_of_freqs= list_of_freqs[list_of_freqs > minimum]
    
    word_list = [w for c, w in enumerate(word_list) if list_of_cats[c] in selected_cat ]
    
    list_of_freqs = [w for c, w in enumerate(list_of_freqs) if list_of_cats[c] in selected_cat ]
    list_of_cats = [w for c, w in enumerate(list_of_cats) if list_of_cats[c] in selected_cat ]
    # u,c = np.unique(word_list, return_counts=True)
    # dict_unique = dict(zip(u,c))
    # list_of_freqs = [s for counter, s in enumerate(list_of_freqs) if dict_unique[word_list[counter]] == 1]
    # list_of_cats = [s for counter, s in  enumerate(list_of_cats) if dict_unique[word_list[counter]] == 1]
    # word_list = [s for  s in word_list if dict_unique[s] == 1]
    
    
    
    #word_list = [s for s in word_list if s in word_list]
    #word_list = np.array([re.sub(signs_to_remove, '', word) for word in word_list if len(word) > 3])
    
    # Creating a df of 3 columns (word, freq, cat)
    df_full = pd.DataFrame(columns = cols_names, 
                           data = np.array([list(word_list), list(list_of_freqs), list(list_of_cats)]).T)
    df_full = df_full.groupby(['word','cat']).sum().reset_index()
    
    word_list_long = np.array([len(w) > min_len_cue for w in df_full['word'].values])
    #                          if len(word.strip()) >= min_len_cue]
    df_full = df_full.iloc[np.where(word_list_long)[0],:]
    df_full = df_full.reset_index()
    list_of_cats = df_full['cat'].values
    #list_of_cats = list_of_cats[np.where(word_list_long)[0]]
    # creating a dictionary of the words from each category
    dict_per_cat_full = {cat:df_full.iloc[np.where(list_of_cats == cat)[0],:] 
                         for cat in selected_cat}
    if 'VB' in selected_cat:
        dict_per_cat_full['VB']['word'] = [treat_verbs(w) for w in dict_per_cat_full['VB']['word'] .values]
        dict_per_cat_full['VB']['word'] = [s if s not in not_to_use else '' for s in dict_per_cat_full['VB']['word'] ]
    dict_per_cat_full['VB'] = dict_per_cat_full['VB'].iloc[np.where([len(w.strip()) > 1 for w in dict_per_cat_full['VB']['word'].values])[0],:]
    # print lengths
    [print([k,len(l)]) for k,l in dict_per_cat_full.items()]
    dict_taken_from_bin = {cat:take_from_bin(df, interval = bin_size[cat], to_sort_by = 'freq')[0] 
                           for cat, df in dict_per_cat_full.items()}
    dict_taken_from_bin_dfs = {cat:take_from_bin(df, interval = bin_size[cat], to_sort_by = 'freq')[1] 
                               for cat, df in dict_per_cat_full.items()}
    
    
    #word_list = []

    #add_tokens_cat_and_freq(word_embeddings,minimum = 1e-5)#1e-95, selected_cat,   wordlist , lang
    
    
    return dict_taken_from_bin, dict_taken_from_bin_dfs, dict_per_cat_full


