
import pandas as pd
import numpy as np
import os
import matplotlib.pyplot as plt
import seaborn as sns
from matplotlib.patches import Rectangle
# Create heatmaps svm based on saved data
save_plot_path = # insert plot path
"""
gpt3
"""
dict_gpt3 = {'path_saved' : # insert gpt3 path,
             'short_name': 'gpt3',
             'long_name' :' gpt3 (embedding)',
             'std_name':'df_stack_std_gpt3'}

"""
word2vec
"""
dict_word2vec = {'path_saved' :  # insert word2vec path,
                 'short_name' : 'word2vec',
                 'long_name' : 'word2vec',
                 'std_name':'df_stack_std_word2vec'}

"""
gpt2
"""
dict_gpt2 = {'path_saved' : # insert gpt2 path,
             'short_name': 'gpt2',
             'long_name' : 'gpt2',
             'std_name':'df_stack_std_gpt2'
             }


"""
human
"""  
dict_human = {'path_saved' : # insert dict human path,
             'short_name': 'Human',
             'long_name' : 'Human',
             'std_name':'df_stack_std_human'
             }

order_models = np.array(['Human','AI','word2vec','gpt2', ' gpt3 (embedding)',  'gpt3 (prompt curie)',
       'gpt3 (prompt davinvci)'])
def load_and_plot(dict_name, ax = [], to_null = False,order_models=order_models, ax_bar = [])    :
    df_stacked = pd.read_csv(dict_name['path_saved'] + os.sep + 'df_stack.csv', index_col=0)
    df_top1 =  pd.read_csv(dict_name['path_saved'] + os.sep + 'df_top1.csv', index_col=0)
    if isinstance(ax, list) and len(ax) == 0:
        fig, ax = plt.subplots()
    if isinstance(ax_bar, list) and len(ax_bar) == 0:
        fig_bar, ax_bar = plt.subplots()        
    
    df_stacked = df_stacked.loc[order_models,:]
    df_top1 = df_top1.loc[order_models[1:],:]
    if to_null:
        df_stacked.loc[dict_name['long_name'],:] = np.nan
    sns.heatmap(df_stacked.astype(float), annot=True,robust=True, cmap='RdBu_r', 
                vmin=0, vmax=1, ax = ax)
    ax.set_xlabel("Predicted")
    ax.set_ylabel("Ground Truth")
    ax.set_title(dict_name['long_name'], fontweight = 'bold', fontsize = 16)
    
    """
    bar
    """

    yerr = pd.read_csv(#put path std+ os.sep + dict_name['std_name'] + '.csv', index_col=0)
    yerr.columns = df_top1.columns
    ax_bar.add_patch(Rectangle((-0.5, 0.45), df_top1.shape[1]*7, 0.1,facecolor='yellow'))
    df_top1.plot.bar(ax=ax_bar, color = 'black', width = 0.3, align='center', alpha=0.5,
                     ecolor='black', capsize=10,yerr = yerr,
                                          legend = False)
    ax_bar.set_ylabel('Top-1 Accuracy')
    #plt.title(model_l)
    ax_bar.set_ylim([0.3, 1])
    #fig.tight_layout()


    ax_bar.spines['top'].set_visible(False)
    ax_bar.spines['right'].set_visible(False)

    #plt.savefig(plotname + '_' + model_l+ '_barplot.png', bbox_inches='tight')
    
#plotname = 'AIs'
fig, axs = plt.subplots(1,3,figsize = (20,5), sharey = True)
fig_bar, axs_bar = plt.subplots(1,3,figsize = (20,5), sharey = True) 
for counter, dict_spec in enumerate([dict_word2vec,dict_gpt2, dict_gpt3]):
    load_and_plot(dict_spec, ax = axs[counter], to_null =False,order_models=order_models,
                  ax_bar = axs_bar[counter])
    axs_bar[counter].set_title(dict_spec['long_name'], fontsize = 16, fontweight = 'bold')
fig.savefig(save_plot_path+os.sep+'together_AI_svm_confmat.png', bbox_inches='tight')
fig_bar.tight_layout(w_pad = 5)
fig_bar.savefig(save_plot_path+os.sep+'together_AI_svm_bar.png', bbox_inches='tight')
    
fig, axs = plt.subplots(1,1,)
fig_bar, axs_bar = plt.subplots(1,1) 
for counter, dict_spec in enumerate([dict_human]):
    load_and_plot(dict_spec, ax = axs, to_null =False,order_models=order_models,
                  ax_bar = axs_bar)
    axs_bar.set_title(dict_spec['long_name'], fontsize = 16, fontweight = 'bold')
fig.savefig(save_plot_path+os.sep+'together_human_svm_confmat.png', bbox_inches='tight')
fig_bar.tight_layout(w_pad = 5)
fig_bar.savefig(save_plot_path+os.sep+'together_human_svm_bar.png', bbox_inches='tight')
