

from sklearn import svm
from sklearn.model_selection import train_test_split
# human = label 0
# AI = label 1
import sqlite3
import pandas as pd
import json
import os
import numpy as np
import gensim
import gensim.downloader
from sklearn.model_selection import KFold
import matplotlib.pyplot as plt
import seaborn as sns
glove_vectors = gensim.downloader.load('glove-twitter-25')
model_l = 'gpt3'# 'word2vec' # or word2vec or gpt3
from transformers import GPT2LMHeadModel
from transformers import GPT2Tokenizer

import time 

global store_gpt3_emb 
store_gpt3_emb = {}
run_an = True
if model_l == 'gpt2':    

    model = GPT2LMHeadModel.from_pretrained('gpt2')  # or any other checkpoint
    global word_embeddings
    word_embeddings = model.transformer.wte.weight  # Word Token Embeddings     
    #position_embeddings = model.transformer.wpe.weight  # Word Position Embeddings     
    tokenizer = GPT2Tokenizer.from_pretrained("gpt2")
    try:
        dict_res = np.load('x_gpt3_round_full.npy', allow_pickle = True ).item()
        x = dict_res['x']
        model_sign = dict_res['model_sign']
        labels = dict_res['labels']
        run_an = False
    except:
        run_an = True
    
if model_l == 'gpt3'    :
    import openai
    openai.api_key = # inser keys
def return_emb_vec(word, model_l = 'word2vec'):
    if model_l == 'word2vec':
        try: 
            vec = glove_vectors[word.lower().strip()].reshape((1,-1))
        except:
            vec = np.zeros((1,len(glove_vectors['hi']))).reshape((1,-1))            
    elif model_l == 'gpt2'            :
        vec = word_embeddings[tokenizer.encode(word)[0],:].detach().numpy().reshape((1,-1))     
    elif model_l == 'gpt3':
        #run_an = False

        if word in store_gpt3_emb.keys():
            vec = store_gpt3_emb[word]
        else:
            time.sleep(5)
            response = openai.Embedding.create(
                 input=word,
                 engine="text-similarity-davinci-001")
            vec = np.array(response['data'][0]['embedding']).reshape((1,-1))       
            store_gpt3_emb[word] = vec
    return vec

save_path = # insert path 
cue_words_list = np.load(save_path + os.sep +'all_cue_words_october_1.npy')
words_humans = np.load(# insert path )


path_model_ass = # insert path 
guess_human_path1 =# insert path 
guess_human_path2 =# insert path 

guess_AI_path = # insert path 
dict_numbers_to_model_name = np.load('dict_numbers_to_model_name.npy',allow_pickle=True).item()

dict_humans = {cue: words_humans[i] for i,cue in enumerate(cue_words_list)}
#{**np.load(guess_human_path1, allow_pickle=True).item() , **np.load(guess_human_path2, allow_pickle=True).item()}
#words_humans    
#list(np.load(guess_human_path1)) + list(np.load(guess_human_path2))
#words_humans = list(np.load(guess_human_path1)) + list(np.load(guess_human_path2))

numSplits = 10     # Number of splits for cross-validation

store_predictions = {}
store_acc = {}
store_conf = {}
store_predictions_test = {}
store_acc_test = {}
store_conf_test = {}
store_mean_diag = {}
def calc_dist_to_cue(cue,guess, model_l = model_l):
    print(guess)
    return (return_emb_vec(cue, model_l  = model_l) - return_emb_vec(guess,model_l = model_l))**2
words_humans     = []
if run_an:
    
    try:
        embeddings_store
    except:
        human_embeddings = []
        embeddings_store = {}
        for cue,guess_opt in dict_humans.items():
            guess_opt = [guess_opt]*5#np.random.choice(guess_opt, 5 )
            for guess in guess_opt:
                words_humans.append(guess)
                if len(human_embeddings) == 0:
                    human_embeddings = calc_dist_to_cue(cue,guess)
                else:
                    human_embeddings = np.vstack([human_embeddings,calc_dist_to_cue(cue, guess, model_l = model_l)])#append(calc_dist_to_cue(cue, guess))
                    
        #human_embeddings = np.vstack([return_emb_vec(w) for w in words_humans])
        #human_embeddings = np.vstack(human_embeddings)
        embeddings_store['human'] = human_embeddings
    #confmat_AI_judge_gpt3

dict_ankur = {}
if run_an:
    x = human_embeddings
    labels = np.zeros(len(human_embeddings))
    model_sign = ['human']*len(human_embeddings)
    counter0 = 0
    for number,model in dict_numbers_to_model_name.items():
        counter0 += 1
        dict_model_cue_guess = np.load(path_model_ass+ os.sep + str(number) + os.sep + 'dict_cue_guess.npy', 
                allow_pickle=True).item()
        model_guess = [dict_model_cue_guess[cue] for cue in cue_words_list]
        embeddings_models0 = np.vstack([calc_dist_to_cue(cue_words_list[counter],w) for counter, w in enumerate(model_guess)])
            
        if counter0 ==  1:
           embeddings_models = embeddings_models0
        else:
           embeddings_models = np.vstack([embeddings_models, embeddings_models0])
        
        embeddings_store[model] = embeddings_models
        labels = np.hstack([labels , np.ones(len(embeddings_models0))])
        #labels = np.hstack([np.zeros(len(human_embeddings)), np.ones(len(embeddings_models))])
        x = np.vstack([human_embeddings, embeddings_models])#np.vstack([human_embeddings, embeddings_models])
        model_sign = model_sign + [model] * embeddings_models0.shape[0]
        print(counter0)
        if  model_l == 'gpt3':
            np.save('x_gpt3_round_%d'%counter0, {'x':x, 'labels':labels,'model_sign':model_sign})
            print('saved')
        
    
predictions_zeros = np.zeros((len(labels)))
#X_train, X_test, y_train, y_test = train_test_split(x, labels, test_size=0.33, random_state=42)
store_conf = []
store_predictions = []
store_acc = []
store_mean_diag = []
kf = KFold(n_splits=numSplits,shuffle=True)
for (i,(train_index, test_index)) in enumerate(kf.split(x)):
    X_train = x[train_index]
    y_train = labels[train_index]
    X_test =  x[test_index]
    y_test = labels[test_index]
        
    ## Train train
    clf = svm.SVC()
    clf.fit(X_train, y_train)
    predictions = clf.predict(X_test)
    #store_predictions[model].append(predictions)
    acc = np.mean(predictions == y_test)
    #store_acc[model].append(acc)
    confmat = np.zeros((2,2))
    
    # rows = true; cols = guess; 
    confmat[0,0] = np.sum((predictions == 0) & (y_test == 0))
    confmat[0,1] = np.sum((predictions == 1) & (y_test == 0))
    confmat[1,0] = np.sum((predictions == 0) & (y_test == 1))
    confmat[1,1] = np.sum((predictions == 1) & (y_test == 1))
    
    predictions_zeros[test_index] = predictions_zeros[test_index] + predictions
    
    #store_conf[model].append(confmat)
    confmat = confmat / np.sum(confmat, axis = 1).reshape((-1,1))
    store_mean_diag.append(confmat[0,0]*0.5 + 0.5*confmat[1,1])
#predictions_zeros = predictions_zeros / numSplits


predictions_zeros = np.round(predictions_zeros).astype(int)


model_res_df = pd.DataFrame( index = ['Human', 'AI'], columns = ['human','AI'] )

    
model_sign = np.array(model_sign)    

small_preds = predictions_zeros[model_sign == 'human'] 
think_human =  np.mean(small_preds < 0.5)
think_ai =         np.mean(small_preds > 0.5)
model_res_df.loc['Human',:] = [think_human, think_ai]


for model in np.unique(list(model_sign)):
    if model != 'human':
        small_preds = predictions_zeros[model_sign == model] 
        small_labels =  labels[model_sign == model] 
        think_human =  np.mean(small_preds < 0.5)
        think_ai =         np.mean(small_preds > 0.5)
        model_res_df.loc[model,:] = [think_human, think_ai]
df_stacked = model_res_df    
df_stacked.loc['AI',:] = df_stacked.iloc[2:,:].sum(0).values
df_stacked.loc['AI',:] = df_stacked.loc['AI',:]/np.sum(df_stacked.loc['AI',:] )
#df_stacked.columns = ['Human', 'AI']
#df_stacked.loc['AI',:] = df.iloc[2:,:].sum(0).values
df_stacked = df_stacked/df_stacked.sum(1).values.reshape((-1,1))
plt.figure();sns.heatmap(df_stacked.astype(float), annot=True,robust=True, cmap='RdBu_r', vmin=0, vmax=1)
plt.xlabel("Predicted")
plt.ylabel("Ground Truth")
plotname = 'AIs'
plt.savefig(plotname + '_' + model_l+ '_confmat.png', bbox_inches='tight')

"""
bar create
"""
df_top1 = pd.DataFrame(index = ['AI'] + list(dict_numbers_to_model_name.values()), columns = ['Top-1 Accuracy'])
store_mean_diag_AI = np.array(store_mean_diag).mean()
for model in np.unique(list(model_sign)):
    if model != 'human':
        df_top1.loc[model,'Top-1 Accuracy'] = model_res_df.loc[model, 'AI']*0.5 + model_res_df.loc['Human', 'human']*0.5 
    df_top1.loc['AI'] = store_mean_diag_AI
"""
bar
"""
fig, ax = plt.subplots();
ax.axhline(0.5, color = 'k', ls = '--',  label='chance (50%)')
fig.legend(loc='upper center', bbox_to_anchor=(0.55, 1.0), ncol=3, 
           fancybox=True, shadow=True,frameon=False)
df_top1.plot.bar(ax=ax, color = 'black', width = 0.3,                                                legend = False)
ax.set_ylabel('Top-1 Accuracy')
#plt.title(model_l)
ax.set_ylim([0, 1])
fig.tight_layout()


ax.spines['top'].set_visible(False)
ax.spines['right'].set_visible(False)

plt.savefig(plotname + '_' + model_l+ '_barplot.png', bbox_inches='tight')
